/* THPSSave by Andrew "CHCNiZ" Learn 
 * Copyright © 2009 Andrew Learn
 *
 *  THPSSave is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  THPSSave is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with THPSSave.  If not, see <http://www.gnu.org/licenses/>.
 */
#include <stdio.h>
#include <stdlib.h>
#include <windows.h>
#include <string.h>
char GamePath[1024];
char SaveDir[256];
char SubKey[256];
char game_title[256];
char RegLoc[256];
void GetDir(void);
char key[256];
int RegErr = 0;
int main(int argc, char *argv[]) {
	int game_id = 0;
	SetConsoleTitle("CHC's THPS Save Opener");
	if(argc == 2) {
game_id = *argv[1];	
}
else if(argc > 2) {
	printf("Error: To many arguments.\n");
	exit(0);
}
else {
	printf("   CHC's THPS Save Folder Opener\n   http://ThMods.com\n\nThis is a simple tool which will open the save folder of the requested game.\n\nFound a bug? email CHCNiZ@hotmail.com and report it.\n\n");
	printf("\t\tWhich game would you like?\n 1 = THPS3, 2 = THPS4, 3 = THUG, 4 = THUG2, 5 = THAW, Default = THUG2\n");
scanf("%d", &game_id);
}

switch(game_id)
{
	case 1: 
	sprintf(game_title,"Tony Hawk's ProSkater 3"); 
	sprintf(SubKey, "InstallPath");
	sprintf(RegLoc,"SOFTWARE\\Activision\\THPS3PC");
	break;
	case 2:
	sprintf(game_title,"Tony Hawk's ProSkater 4"); 
	sprintf(SubKey, "path");
	sprintf(RegLoc,"SOFTWARE\\Aspyr Media\\Tony Hawks Pro Skater 4f\\Install");
	break;
	case 3:
	sprintf(game_title,"Tony Hawk's Underground"); 
	sprintf(SubKey, "InstallPath");
	sprintf(RegLoc,"SOFTWARE\\Activision\\Tony Hawk's Underground");
	break;
	case 4:
	sprintf(game_title,"Tony Hawk's Underground 2"); 
	sprintf(SubKey, "InstallPath");
	sprintf(RegLoc,"SOFTWARE\\Activision\\Tony Hawk's Underground 2");
	break;
	case 5:
	sprintf(game_title,"Tony Hawk's American Wasteland"); 
	sprintf(SubKey, "Path");
	sprintf(RegLoc,"SOFTWARE\\Aspyr\\Tony Hawk's American Wasteland\\Install");
	break;
	default:
	sprintf(game_title,"Tony Hawk's Underground 2"); 
	sprintf(SubKey, "InstallPath");
	sprintf(RegLoc,"SOFTWARE\\Activision\\Tony Hawk's Underground 2");
	break;
		
}

GetDir();
	if(RegErr == 0) {
	char syscmd[256];
if(game_id == 1) { //If is THPS3
		sprintf(SaveDir, "%s\\Data\\Settings", GamePath);
	}
else if((game_id == 2) || (game_id == 5)) { //If is THPS4 or THAW

	sprintf(SaveDir, "%sGame\\Save", GamePath);
}
else {
	sprintf(SaveDir, "%s\\Game\\Save", GamePath);
	}

	sprintf(syscmd,"explorer \"%s\"", SaveDir); 
	//printf("%s", syscmd);
	system(syscmd);
	printf("\nYour save folder is %s\n\n", SaveDir);
	system("PAUSE");
	exit(0);
	}
	else {
		
		printf("Error: Couldn't open registry key. Perhapes this game is not installed?\n");
system("PAUSE");
		exit(1);
	}
	}
void GetDir() {
HKEY hKey;
char data[1024]; //Shouldn't pass this
unsigned long type;
unsigned long size = 1024;

	if(RegOpenKeyEx(HKEY_LOCAL_MACHINE, RegLoc, 0, KEY_READ, &hKey) == ERROR_SUCCESS) {
		if(RegQueryValueEx(hKey, SubKey, 0, &type, (LPBYTE)&data, &size) != ERROR_SUCCESS) RegErr = 1;
		RegCloseKey(hKey);
	} else RegErr = 1;

	// set game path

	sprintf(GamePath, "%s", data);

}
